import { Compiler } from 'webpack';

export type CommonOptions = {
  cache?: boolean;
  verbose?: boolean;
  env?: string;
  mode?: 'development' | 'production' | 'none';
  root?: string
};

export type CoreOptions = CommonOptions & {
  analyzeWeb?: boolean,
  analyzeServer?: boolean,
  cdnUrl?: string,
  appUrl?: string,
  envVars?: {
    [key: string]: any;
  };
};

export type ConfigOptions = CoreOptions & {
  analyze?: boolean;
  outputPath?: string;
  resourceUrl?: string;
  assetsBase?: string;
  extractCSS?: boolean;
};

export type RunOptions = {
  watch?: boolean,
};

export type ServerCompilers = {
  webCompiler: Compiler;
  serverCompiler: Compiler;
};

export type ServerOptions = {
  host: string;
  port: number;
};

export type WebpackConfigOptions = {
  target: 'web' | 'node';
};
