import presetEnv from '@babel/preset-env';
import presetReact from '@babel/preset-react';
import presetTypescript from '@babel/preset-typescript';
import packageJson from '../../package.json';

type LoaderPresetOptions = {
  node?: boolean;
};
const LoaderPresets = (options: LoaderPresetOptions = { node: false }) => [
  [
    presetEnv,
    {
      ...(options.node ? { targets: { node: '12' } } : {}),
      ...(!options.node ? {
        useBuiltIns: 'entry',
        corejs: {
          version: packageJson.dependencies['core-js'],
          proposal: true,
        },
      } : {}),
    },
  ],
  [
    presetReact,
    {
      runtime: 'automatic',
    },
  ],
  presetTypescript,
];

export { LoaderPresets };
