import isObject from 'is-object';

const normalizeAssets = (stats: any) => {
  const { assetsByChunkName, publicPath } = stats;

  if (assetsByChunkName?.client && isObject(assetsByChunkName?.client)) {
    return Object.values(assetsByChunkName?.client)
      .map((assetPath) => `${publicPath}${assetPath}`);
  }

  if (assetsByChunkName?.server && isObject(assetsByChunkName?.server)) {
    return Object.values(assetsByChunkName?.server)
      .map((assetPath) => `${publicPath}${assetPath}`);
  }
  const assets = assetsByChunkName?.client ?? assetsByChunkName?.server ?? [];
  return Array.isArray(assets) ? assets : [assets];
};

export { normalizeAssets };
