import React, { PropsWithChildren } from 'react';
import { PartialRouteObject } from 'react-router';
import { useRoutes } from 'react-router-dom';
import { Html } from './html';

type AppParams = {
  assets: string [],
  routes: PartialRouteObject[],
};

const App: React.FC<AppParams> = (
  {
    children,
    assets,
    routes,
  }: PropsWithChildren<AppParams>,
) => {
  const element = useRoutes(routes);
  return (
    <Html assets={assets}>
      {children}
      {element}
    </Html>
  );
};

export { App };
