import { StatsCompilation } from 'webpack';
import express from 'express';
import path from 'path';
import { StandaloneServer } from './standalone';
import { getEnvHost, getEnvPort } from '../util/env';
import { normalizeAssets } from '../common/normalize';

const server = new StandaloneServer();

if (process?.argv?.length >= 2) {
  // eslint-disable-next-line no-eval
  const runtimeModule = eval('require.main');
  if (runtimeModule.filename === __filename) {
    // eslint-disable-next-line no-eval
    eval('require(\'events\').EventEmitter.prototype._maxListeners = 100');
    // eslint-disable-next-line no-eval
    const data: StatsCompilation = eval('require(\'./__web_assets.json\')');
    const publicPath = data?.publicPath ?? '';
    const assets = normalizeAssets(data);
    const cacheTime = 86400000 * 30;
    server.setPublicPath(publicPath);
    server.setAssets(assets);
    server.addMiddleware(publicPath, express.static(path.join(__dirname, 'build'), {
      maxAge: cacheTime,
    }));
    server.handleRequests();
    server.start({
      host: getEnvHost(),
      port: getEnvPort(),
    });
  }
}

export { server };
