import { getEnv } from './common';
import { DEVELOPMENT } from '../constants';

export const getEnvCache = () => getEnv(
  'PAW_CACHE',
  process.env?.PAW_CACHE ?? 'false',
  'boolean',
) as boolean;

export const getEnvVerbose = () => getEnv(
  'PAW_VERBOSE',
  process.env?.PAW_VERBOSE ?? 'false',
  'boolean',
) as boolean;

export const getEnvEnvironment = () => getEnv(
  'PAW_ENV',
  process.env?.PAW_ENV ?? DEVELOPMENT,
  'string',
) as string;

export const getEnvMode = () => getEnv(
  'PAW_COMPILE_MODE',
  process.env?.PAW_COMPILE_MODE ?? DEVELOPMENT, 'string',
) as ('production' | 'development');

export const getEnvPort = () => getEnv(
  'PORT',
  process.env?.PORT ?? '9090',
  'number',
) as number;

export const getEnvHost = () => getEnv(
  'HOST',
  process.env?.HOST ?? '0.0.0.0',
  'string',
) as string;

export const getEnvAnalyzeWeb = () => getEnv(
  'PAW_ANALYZE_WEB',
  process.env?.PAW_ANALYZE_WEB ?? 'false',
  'boolean',
) as boolean;

export const getEnvAnalyzeServer = () => getEnv(
  'PAW_ANALYZE_SERVER',
  process.env?.PAW_ANALYZE_SERVER ?? 'false',
  'boolean',
) as boolean;

export const getEnvVars = () => {
  const value = getEnv(
    'PAW_PROJECT_VARS',
    process.env?.PAW_PROJECT_VARS ?? JSON.stringify({}),
    'string',
  ) as string;
  try {
    return JSON.parse(value);
  } catch (ex) {
    return {};
  }
};
