import * as packageJson from '../../package.json';

const {
  name, version, dependencies,
} = packageJson;

export const getReplacementVars = (projectName?: string, projectPath?: string) => {
  const replacementVars: {
    [key: string]: string,
  } = {
    projectName: projectName ?? '',
    projectPath: projectPath ?? '',
    packageName: name,
    packageVersion: version,
    typesReactVersion: dependencies['@types/react'],
    typesReactDomVersion: dependencies['@types/react-dom'],
    reactVersion: dependencies.react,
    reactDomVersion: dependencies['react-dom'],
    eslintVersion: dependencies.eslint,
    eslintConfigAirbnbTypescriptVersion: dependencies['eslint-config-airbnb-typescript'],
    typescriptEslintPluginVersion: dependencies['@typescript-eslint/eslint-plugin'],
    typescriptVersion: dependencies.typescript,
  };
  return replacementVars;
};
