import webpack, { Compilation, sources } from 'webpack';

class ExtractEmittedAssets {
  options: any;

  constructor(options: any = {}) {
    this.options = options;
  }

  // eslint-disable-next-line class-methods-use-this
  apply(compiler: webpack.Compiler) {
    compiler.hooks.thisCompilation.tap('ExtractEmittedAssets', (compilation: Compilation) => {
      compilation.hooks.processAssets.tap(
        {
          name: 'ExtractEmittedAssets',
          stage: Compilation.PROCESS_ASSETS_STAGE_ADDITIONS,
        },
        () => {
          const serverContent = compilation.getStats().toJson({
            modules: true,
            reasons: true,
            relatedAssets: true,
            assets: true,
            chunks: true,
          });
          compilation.emitAsset('../__web_assets.json', new sources.RawSource(JSON.stringify(serverContent)));
        },
      );
    });
  }
}

export default ExtractEmittedAssets;
